function [ distance ] = harvesineDistance( p1, p2)
% Calculates the Harvesine distance between two points

R = 6371;   % Earth's radius in km 

delta_lat =  deg2rad(p2(:,1)) -  deg2rad(p1(:,1));        % differences in latitude
delta_lon =  deg2rad(p2(:,2)) -  deg2rad(p1(:,2));        % differences in longitude
a = sin(delta_lat/2).^2 + cos( deg2rad(p1(:,1))) .* cos( deg2rad(p2(:,1))) .* ...
        sin(delta_lon/2).^2;
c = 2 * atan2(sqrt(a), sqrt(1-a));
distance = R * c;  

end

